﻿Type=Service
Version=6
ModulesStructureVersion=1
B4A=true
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: true
	#StartCommandReturnValue: android.app.Service.START_STICKY
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	
	Dim PE As PhoneEvents
	Dim panicBatteryLevel As Int = 18
	
	Dim Program2RunWhenCharging As String = "com.sadLogic.KitchenEssentials"
	Dim Program2RunWhenNotCharging As String = "com.plexapp.android"
	Dim Intent2RunWhenCharging As Intent
	Dim Intent2RunWhenNotCharging As Intent
	
	Dim PluggedIn As Boolean
	Dim FirstRun As Boolean = True
	

End Sub

Sub Service_Create
	'--- all we do is start this app at startup
	
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.SetInfo("App Power Switcher","",Main)
	n.Notify(1)
	
	PE.Initialize("PhEvents")	
	Intent2RunWhenCharging = GetProgramIntent(Program2RunWhenCharging)
	Intent2RunWhenNotCharging = GetProgramIntent(Program2RunWhenNotCharging)
	logIt("service start")
	
End Sub

Sub Service_Start (StartingIntent As Intent)
	logIt("sticky service service start")
End Sub

Sub Service_Destroy

End Sub





Sub PhEvents_BatteryChanged (Level As Int, Scale As Int, Plugged As Boolean, Intent As Intent)
	
	logIt(DateTime.Time(DateTime.Now) & "   The battery level is: " & Level & "   Scale: " & Scale & "  Plugged: " & Plugged)
	
	If FirstRun Then
		logIt("First run")
		FirstRun = False
		PluggedIn = Plugged
	Else
		If Plugged = PluggedIn Then
			'--- we are in the right mode  :)  Do nothing
			logIt("we are in the right mode  :)  Do nothing")
			Return
		Else
			If Level < panicBatteryLevel Then
				logIt("Batt level check, falling through")
				'--- time to put back in the charger, beep or something
				'--- TODO	
			End If
		End If
	End If
	

	If Plugged Then
		logIt("switching to charge app")
		StartApp(Intent2RunWhenCharging,Null)
	Else
		logIt("switching to NON charge app")
		StartApp(Intent2RunWhenNotCharging,Null)		
	End If
	
	'--- reset the mode
	PluggedIn = Plugged
	
End Sub


Sub GetProgramIntent(prgName As String) As Intent
	Try
    	Dim pm As PackageManager
    	Return pm.GetApplicationIntent(prgName)
	Catch
    	logError("Problem getting intent for  " & prgName)
		Return Null
	End Try
End Sub


Sub StartApp(i As Intent,cargo As Map)
	Try
		'--- cargo not used at the moment
		StartActivity (i)
	Catch
		logError(LastException)
	End Try
End Sub


Sub logError(s As String)
	'--- log to file in future?
	Log(S)
End Sub

Sub logIt(s As String)
		Log(s)
End Sub



Private Sub ShowInstalledApps 'ignore

	#if debug
	
	'--- this is a helper method to find installed package names
	'--- this is a helper method to find installed package names
	'--- this is a helper method to find installed package names
	
	Dim args(1) As Object
   	Dim Obj1, Obj2, Obj3 As Reflector
   	Dim size, i, flags As Int
   	Dim Types(1), name,packName As String
	'Dim icon As BitmapDrawable
   	Obj1.Target = Obj1.GetContext
   	Obj1.Target = Obj1.RunMethod("getPackageManager") ' PackageManager
   	Obj2.Target = Obj1.RunMethod2("getInstalledPackages", 0, "java.lang.int") ' List<PackageInfo>
   	size = Obj2.RunMethod("size")
   	For i = 0 To size -1
	
      	Obj3.Target = Obj2.RunMethod2("get", i, "java.lang.int") ' PackageInfo
      	packName = Obj3.GetField("packageName")
		
		Obj3.Target = Obj3.GetField("applicationInfo") ' ApplicationInfo      
      	flags = Obj3.GetField("flags")   
		
      	flags = Obj3.GetField("flags")   
		
	   	If Bit.And(flags, 1)  = 0 Then
	        'app is not in the system image
	    	args(0) = Obj3.Target
	      	Types(0) = "android.content.pm.ApplicationInfo" 
	      	name = Obj1.RunMethod4("getApplicationLabel", args, Types)
			'icon = Obj1.RunMethod4("getApplicationIcon", args, Types)
			'lv.AddTwoLinesAndBitmap2(name,"",icon.Bitmap,packName)
			Log("-------------------------------------------------------------")
			Log(name & " --> " & packName)
			Log("-------------------------------------------------------------")
	   	End If      
   Next   
   #end if
   
End Sub



